var http = require("http");
var url  = require("url");
var crypto = require('crypto');


//
// API config settings
//
var apiconf = {};
apiconf.serverUrl    = "http://yoursite.com/a530/php";
apiconf.apiuser      = "user@example.com";
apiconf.apikey       = "9ah4KHZhfy...xxxxxx";
apiconf.annotateuser = "user@example.com";


//
// Example calling an API function
//
function testListUsers(apiconf) {
    var phpfn = "listUsers.php";
    var validfor = 0;
    
    var req = signRequest(phpfn, apiconf.apiuser, apiconf.apikey, apiconf.annotateuser, validfor);
        
    var u = apiconf.serverUrl + "/" + phpfn + "?" + req;

    fetchUrl(u, done, err);

    function done(txt) {
        //  console.log("Fetched "+txt);
        if (txt.substr(0,1)=="{") { // assume json
            var parsed = JSON.parse(txt);
            console.log("Parsed to JSON as: \n" + JSON.stringify(parsed,1));
        } else {
            console.log("Doesn't look like json: \n" + txt);
        }
    }

    function err(msg) {
        console.log("Test request error "+msg);
    }
}


testListUsers(apiconf);







// ---- generic util + signing functions below ----

// Fetch a url, cbdone() on ok, cberr(msg) on not
// NB could npm install 'request'... just making this depenency-free
function fetchUrl(u, cbdone, cberr) {
    var options = url.parse(u);

    var req = http.get(options, handler);
    req.on("error", reqError);

    function handler(resp) {
        var body = "";
        function appendChunk(d) {
            body += d;
        }
        function allDone() {
            cbdone(body);
        }
        resp.on("data", appendChunk);
        resp.on("end", allDone);
    }
    function reqError(e) {
        cberr(e);
    }    
}

function signString(apikey, msg) {
    var hash = crypto.createHmac('sha1', apikey).update(msg).digest('base64');
    return hash;
}

function enc(str) {
    return encodeURIComponent(str);
}

function signRequest(phpfn, apiuser, apikey, annotateuser, validfor) {
    var requesttime = Math.floor((new Date()/1000)) + validfor;

    var stringToSign = phpfn + "\n" + apiuser + "\n" + requesttime + "\n" + annotateuser;

    // console.log(stringToSign);
    
    var sig = signString(apikey, stringToSign);

    return "api-user=" + enc(apiuser) + 
        "&api-requesttime=" + requesttime +
        "&api-annotateuser=" + enc(annotateuser)+
        "&api-auth="+enc(sig);
}





