<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<title>Sample embedding an Annotate frame within another page</title>
<style>

body {
  font-family: Verdana, Helvetica, sans-serif;
  font-size: 10pt;
  padding: 0px; margin:0px;
}

div#main, p {
  margin:1em;
}

</style>
</head>
<body>

<div id='main'>
<h2>Using Annotate within external systems</h2>

<p><em>
This is a simple demo to show how an Annotate panel can be integrated 
within existing systems for document workflow. The PDF window below shows 
a document which has been fetched from a URL; the user can add annotations 
(text selection, region and free-hand).
This example page is in PHP, but could as easily have been written
in other web languages as the API is based on simple HTTP GET.
</em>
</p>

</div>

<?php

  //
  // *** Copy 'api-sample-code/php/test_config-sample.php' to 'api-sample-code/php/test_config.php'
  // Edit $annotateServer - change this to point at the URL of your local annotate server e.g. 'http://mysite.com/annotate'
  // Edit $apiuser (server admin's email) and $apikey which can be found at the bottom of your settings page
  //

	if (!file_exists("test_config.php")) {
		print "<p style='color:red;'>'test_config.php' not found. Please copy 'api-sample-code/php/test_config-sample.php' 
		to 'api-sample-code/php/test_config.php' and edit apiuser, apikey and annotateServer</p>\n";
		exit;
	}
	require_once("annotateApi.php"); // includes 'test_config.php'

  // *** Change this if you wish to upload a different document
  $docurl = "$annotateServer/welcome/version52/welcome-to-annotate.pdf";
 
  // *** The iframe's src link will log the following user in 
  // and create the account if it doesn't exist yet.
  $annotateuser = "jill@example.com";

  $projectid = ""; // optional, string to name destination workspace. If no projectid supplied, the document will be uploaded to the API user's default workspace
  $nocache = "";   // optional, "1" to force a refetch of the same PDF URL each time
  $hide = "";      // optional, e.g. "gti-sgo", codes for hiding gui components
  

  // This call fetches the PDF from the given URL and returns
  // a link which you can use as the src of an iframe.
  $phpfn = "simpleUpload.php";
  $request = signRequest($phpfn, $apiuser, $apikey, $annotateuser);
  
  $uploadurl = "$annotateServer/php/$phpfn?$request";
  $uploadurl .= "&url=".rawurlencode($docurl);
  $uploadurl .= "&hide=".rawurlencode($hide);
  $uploadurl .= "&projectid=".rawurlencode($projectid);
  $uploadurl .= "&nocache=$nocache";
  $ret = file_get_contents($uploadurl);
      
  // The return value is something like: 
  // "OK loginAs.php?d=2017-01-01&c=abcdef&ws=12345678"
  // or "ERR <error message>"
  
  if (substr($ret, 0, 2) == "OK") {
     $phpfn = "loginAs.php";
     $authparams = signRequest($phpfn, $apiuser, $apikey, $annotateuser);
     $embedsrc = "$annotateServer/php/$phpfn?$authparams";
     $embedsrc .= "&loc=".rawurlencode(substr($ret, 3));
     
     // If the user account doesn't exist in Annotate, create it
     $embedsrc .= "&create=1";
     $embedsrc .= "&firstname=jill"; // optional
     $embedsrc .= "&lastname=smith"; // optional
     $embedsrc .= "&sig=jill";       // optional
     
     // Get the workspace id into which the document has been uploaded
     $pos = strpos($ret, "&ws=");
     if ($pos) { $ws = substr($ret, $pos+4, 9); }
     
     // Add user to the workspace so that he can access the document
     $embedsrc .= "&add=1";
     $embedsrc .= "&ws=$ws";
     $embedsrc .= "&role=3"; // role 'User' - can access the docs and make notes

     // The link to allow the sample user to view the document and make annotations
     print "<p style='margin:1em'>You can also ";
     print "<a target='_blank' href='".$embedsrc."'>open the page in a new window</a></p>\n\n";

     // Include an iframe which embeds the PDF
     print "<iframe src='$embedsrc' style='border:1px solid black' width='100%' height='80%'></iframe>\n\n";
  }
  else {
    print "<p style='color:red;'>There was a problem uploading $docurl ( $ret )  from the annotate server at URL: $annotateServer (url : $uploadurl)</p>\n";
  }
      
?>


</body>
</html>