<?php

  //
  // Test uploading document from command line - with revisions.
  //

require_once("annotateApi.php");


function doUpload($params, $files, $repo="") {
  global $sampleUser, $apiuser, $apikey, $annotateServer;
  $phpfn = "uploadDocument.php";
  $annotateuser = $sampleUser; // e.g. "joe3@textensor.com";
  $validfor = 60 * 30; // valid for 30 mins
  $request = signRequest($phpfn, $apiuser, $apikey, $annotateuser, $validfor);
  $url = "$annotateServer/php/$phpfn?$request";
  if ($repo) { $url.="&repoid=$repo"; }
  // print $url;
  $ret = doPost($url, $params, $files);
  return $ret;
}

$uplrepo = "";
$uplrepo = "101"; // to send to given repoid
$params1 = array("ws" => $sampleWS,
                "desc" => "Initial version",
                "tags" => "tag1, tag2"
                );
$sampleUser = $apiuser;

$files1 = array("Filedata" => "hamlet1.pdf");
$ret = doUpload($params1, $files1, $uplrepo);

if (substr($ret, 0, 3) == "ERR") {
  print "Returned error: $ret\n";
 }
 else {
   $bits = explode(" ", $ret);
   $date = $bits[1];
   $code = $bits[2];

   print "V1:\n";
   print "$ret\n"; // Upload v1, ID: $date $code \n";

   $params2 = array("ws" => $sampleWS,
                    "desc" => "new version",
                    "tags" => "tag1, tag2",
                    "revisionOf" => "$date/$code"
                );

   $files2 = array("Filedata" => "hamlet2.pdf");
   $ret = doUpload($params2, $files2, $uplrepo);

   if (substr($ret,0,3)=="ERR") {
     print $ret;
   }
   else {
     print $ret;
     $bits = explode(" ", $ret);
     print "\npdfnotate.php?d=".$bits[1]."&c=".$bits[2];
     if ($uplrepo) { print "&repoid=$uplrepo"; }
     print "\n";
   }
 }
//  


?>